
Ext.define('MemoApp.controller.MainController', {
	extend : 'Ext.app.Controller',
	
	requires :[
		'MemoApp.view.MainView',
		'MemoApp.view.MemoListView',
		'MemoApp.view.MemoView',
		'MemoApp.view.MemoEditView',
		'MemoApp.model.MemoModel',
		'MemoApp.store.Memos'
	],
	
  views	: [
		'MainView',
		'MemoListView',
		'MemoView',
		'MemoEditView'
	],
	models: ['MemoModel'],
	stores: ['Memos'],
  refs: [
    {
      ref: 'memoListView',
      selector: 'memolistview'
    },
		{
      ref: 'memoView',
      selector: 'memoview'
    },
		{
      ref: 'memoEditView',
      selector: 'memoeditview'
    },
		{
      ref: 'memoStore',
      selector: 'memostore'
    }
  ],
	
 	init : function() {
		Ext.create('MemoApp.view.MainView');
    this.control({
      '#memo-list-view': {
        show: this.onShowMemoList,
        select: this.onListSelectMemoList
      },
      '#memo-view': {
				hide: this.onHideMemoView
      },
      '#new-memo-button': {
        tap: this.onNewMemoButtonTap
      },
      '#close-edit-button': {
        tap: this.onEditCloseButtonTap
      },
			'#save-edit-button': {
        tap: this.onEditFinishButtonTap
      },
			'#delete-memo-button': {
        tap: this.onDeleteButtonTap
      }

		});
		
		var memo_list_view = Ext.getCmp('memo-list-view')
		memo_list_view.on('selectionchange', this.onSelectionchangeMemoList);
		
		this.loadData();
	},
	onSelectionchangeMemoList: function() {	
		console.log('onSelectionchangeMemoList');
	},
	onShowMemoList: function() {	
		console.log('onShowMemoList');
	},
  onListSelectMemoList: function(list, memodata) {
		console.log('onListSelectMemoList');
		console.log(list);
		console.log(memodata);
		console.log(memodata.id);
		var memo_view = Ext.getCmp('memo-view');
    var form = memo_view.down('formpanel');;
    form.setRecord(memodata);
    memo_view.show();		
  },
  onNewMemoButtonTap: function(button, event, obj,cntr) {
		console.log('onNewMemoButtonTap-----------');
		console.log(button);
		console.log(event);
		console.log(obj);
		console.log(cntr);
		//var new_memo = Ext.getCmp('memo-view');
		var new_memo = this.getMemoEditView();
		
    //var form = memo_view.down('formpanel');;
    //form.setRecord(memodata);
    new_memo.show();		
	},
	onEditCloseButtonTap: function(button, event, obj,cntr) {
		console.log('onEditCloseButtonTap-----------');
		console.log(button);
		console.log(event);
		console.log(obj);
		console.log(cntr);
		var new_memo = this.getMemoEditView();
    new_memo.hide();
	},
	onEditFinishButtonTap: function(button, event, obj,cntr) {
		console.log('onEditFinishButtonTap-----------');
    var new_memo = this.getMemoEditView();
    var form = new_memo.down('formpanel');
    var values = form.getValues();
		console.log(values['memoedit']);

		var list = this.getMemoListView();
		var store = list.getStore();
		console.log("pre total items:"+store.getCount());
		var now = new Date();
		
		/*
		 * http://www.sencha.com/forum/showthread.php?158597-Sync-ajax-store-to-offline-site&highlight=localstorage%2C+sync
		 * store経由でlocalstorage使うとバグがある。
		 * 特にstore.sync();
		 * 従って現時点ではExt.createでモデル作成して追加のほうが良い
		store.add({id: Math.ceil(Math.random()*1000),
			date:Ext.Date.format( now, 'Y-m-d H:i:s'),
			memo:values['memoedit']
		});
		store.sync();
		*/
		
		var myMemo = Ext.create('MemoApp.model.MemoModel',
			{
				id: Math.ceil(Math.random()*1000),
				date:Ext.Date.format( now, 'Y-m-d H:i:s'),
				memo:values['memoedit']
			}
		);
		myMemo.save();
		this.loadData();
		console.log("after total items:"+store.getCount());		
		
    new_memo.hide();
	},
	loadData: function() {
    var store = this.getMemoStore(),
        list = this.getMemoListView();
    if (list.getStore() == null) {
			console.log('no store')
      list.setStore(store);
      store.load();
    } else {
			console.log('yes store');
			list.getLastSelected()&&list.deselect(list.getLastSelected());
      list.getStore().removeAll();
      list.getStore().load();
			console.log("total items:"+list.getStore().getCount());
    }
		return list.getStore();
  },
	onHideMemoView: function(cmp,opt,evtcntr) {
		console.log('onHideMemoView');
		console.log(cmp);
		console.log(opt);
		console.log(evtcntr);
		var list = this.getMemoListView();
		list.getLastSelected()&&list.deselect(list.getLastSelected());
	},
	onDeleteButtonTap: function() {
		console.log('onDeleteButtonTap');
    var store = this.getMemoStore(),
        list = this.getMemoListView();
    if (list.getStore()) {
			store = list.getStore();
    }
		store.getProxy().clear();
		this.loadData();
	}

});
